﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Data;

public partial class Default2 : System.Web.UI.Page
{
    protected void Page_Init(object sender, EventArgs e)
    {
        Panel panel1 = new Panel();
        panel1.ID = "Panel1";
        form1.Controls.Add(panel1);

        RadComboBox combo = new RadComboBox();
        combo.ID = "RadComboBox1";
        combo.AppendDataBoundItems = true;
        combo.Items.Add(new RadComboBoxItem("", ""));
        combo.DataTextField = "Item";
        combo.DataValueField = "ID";
        panel1.Controls.Add(combo);

        Panel panel2 = new Panel();
        panel2.ID = "Panel2";
        form1.Controls.Add(panel2);

        RadGrid grid = new RadGrid();
        grid.ID = "RadGrid1";
        grid.MasterTableView.DataKeyNames = new string[] { "ID" };
        grid.MasterTableView.CommandItemDisplay = GridCommandItemDisplay.Top;
        grid.NeedDataSource += new GridNeedDataSourceEventHandler(grid_NeedDataSource);
        grid.ItemCommand += new GridCommandEventHandler(grid_ItemCommand);
        panel2.Controls.Add(grid);
    }

    protected void Page_PreRender(object sender, EventArgs e)
    {
        RadAjaxManager1.AjaxSettings.AddAjaxSetting(this.FindControl("Panel1"), this.FindControl("Panel1"));
        RadAjaxManager1.AjaxSettings.AddAjaxSetting(this.FindControl("Panel1"), this.FindControl("Panel2"));
    }

    void grid_ItemCommand(object source, GridCommandEventArgs e)
    {
        if (e.CommandName == RadGrid.PerformInsertCommandName)
        {
            DataTable table = Data;
            GridEditableItem item = e.Item as GridEditableItem;
            string id = (item.EditManager.GetColumnEditor("ID") as GridTextBoxColumnEditor).TextBoxControl.Text;
            string value = (item.EditManager.GetColumnEditor("Item") as GridTextBoxColumnEditor).TextBoxControl.Text;
            table.Rows.Add(id, value);
            Data = table;

            RadComboBox combo = this.FindControl("Panel1").FindControl("RadComboBox1") as RadComboBox;
            combo.DataSource = Data;
            combo.DataBind();
        }
    }

    void grid_NeedDataSource(object source, GridNeedDataSourceEventArgs e)
    {
        (source as RadGrid).DataSource = Data;
    }
    private DataTable Data
    {
        get
        {
            if (Session["Data"] == null)
            {
                DataTable table = new DataTable();
                table.Columns.Add("ID");
                table.Columns.Add("Item");                
                Session["Data"] = table;
            }
            return (DataTable)Session["Data"];
        }
        set
        {
            Session["Data"] = value;
        }
    }
}
